import pytest
from dotenv import load_dotenv

from ci_agents.runner import analyze_failure
from ci_agents.types import AnalysisContext


# todo: fix the hub agent return??


@pytest.mark.asyncio
async def test_analyze_failure():
    load_dotenv()
    result = await analyze_failure(analyze_context)
    print(result)


analyze_context = AnalysisContext()
analyze_context.failure_log = """{"failure_time": "2025-03-25T22:55:19.393000+08:00 to None", "error_text": "[SERVICE_WEB_API_ENV_ERROR] com.ringcentral.tod.exceptions.apiException.backend.ServiceWebApiException: HTTP 502 Bad Gateway"}"""
analyze_context.failed_thread_log = """03-25 22:55:19.467 INFO BeatsV2ApiClient.createStep(line:266)             >>> create step success, step id = 1660188442 ,step name =  [ BEFORE Hook Failed]: == device are: ===Appium=http://10.32.46.140:4739/-UDID=R52N919EZWZ-DeviceName=s1_behind_l1-Version=13======Appium=http://10.32.46.144:4732/-UDID=R52N61JKQGJ-DeviceName=167-Version=9======Appium=http://10.32.46.144:4730/-UDID=1A071FDF600BW1-DeviceName=Pixel 6-Version=15=== , time cost = 73ms
03-25 22:55:19.478 INFO MyHttpLoggingInterceptor.lambda$getHttpLoggingInterceptor$0(line:15)>>> --> GET http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788203004/cloud-calendars/ucc/exchange/~/
03-25 22:55:19.478 INFO EnhancedHttpLoggingInterceptor.intercept(line:28) >>> --> GET http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788203004/cloud-calendars/ucc/exchange/~/ 
03-25 22:55:26.022 INFO EnhancedHttpLoggingInterceptor.intercept(line:45) >>> <-- RCRequestId = 1fa8f77b-feab-4860-b062-9aa85ce93048
03-25 22:55:26.022 INFO EnhancedHttpLoggingInterceptor.intercept(line:47) >>> <-- 200 OK http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788203004/cloud-calendars/ucc/exchange/~/ (6542ms 290-byte [])
03-25 22:55:26.023 INFO MyHttpLoggingInterceptor.lambda$getHttpLoggingInterceptor$0(line:15)>>> <-- 200 OK http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788203004/cloud-calendars/ucc/exchange/~/ (6544ms, unknown-length body)
03-25 22:55:26.023 INFO CINPlatformApiClient.getCalendars(line:122)       >>> {"records":[{"providerId":"Exchange","calendarId":"AQMkAGVjOTUxODEwLTViMmUtNDJkZAAtODQxOC1mYWJhMTlkOTAzOWQALgAAAwtTe3WA8nZMqLdxh9lZAaoBANJ9sojKuvRMpCMoQfiuz5gAAAIBDQAAAA\u003d\u003d","name":"Calendar","connected":true,"primary":false}],"paging":{"perPage":0}}
03-25 22:55:26.024 INFO MyHttpLoggingInterceptor.lambda$getHttpLoggingInterceptor$0(line:15)>>> --> GET http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788225004/cloud-calendars/ucc/exchange/~/
03-25 22:55:26.024 INFO EnhancedHttpLoggingInterceptor.intercept(line:28) >>> --> GET http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788225004/cloud-calendars/ucc/exchange/~/ 
03-25 22:55:31.948 INFO EnhancedHttpLoggingInterceptor.intercept(line:45) >>> <-- RCRequestId = b068f5fd-ef48-4329-b524-1fa19be89750
03-25 22:55:31.949 INFO EnhancedHttpLoggingInterceptor.intercept(line:47) >>> <-- 200 OK http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788225004/cloud-calendars/ucc/exchange/~/ (5922ms 524-byte [])
03-25 22:55:31.949 INFO MyHttpLoggingInterceptor.lambda$getHttpLoggingInterceptor$0(line:15)>>> <-- 200 OK http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788225004/cloud-calendars/ucc/exchange/~/ (5924ms, unknown-length body)
03-25 22:55:31.950 INFO CINPlatformApiClient.getCalendars(line:122)       >>> {"records":[{"providerId":"Exchange","calendarId":"AAMkADQxNDdlMjU3LTdiZWUtNGE0Zi1hMGY1LWUyY2NhYmQ0YTYwMgAuAAAAAAA4nGMOp42UQ6YiGwGZBZiFAQBvWiZgUUm+QrF9b3TZjoTpAAAAAAENAAA\u003d","name":"Calendar","connected":true,"primary":false,"providerSubscription":{"id":"HABleDIwMTYucmN2aW50LmxhYi5ub3JkaWd5LnJ1EAAAAAiRqbvtWDdEiKE5+fxtpSa/ek3YT2vdCBAAAABX4kdB7ntPSqD14syr1KYC","expirationTime":"2025-03-26T03:48:03.351Z","active":true}}],"paging":{"perPage":0}}
03-25 22:55:31.954 INFO MyHttpLoggingInterceptor.lambda$getHttpLoggingInterceptor$0(line:15)>>> --> GET http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788203004/cloud-calendars/ucc/exchange/~/AQMkAGVjOTUxODEwLTViMmUtNDJkZAAtODQxOC1mYWJhMTlkOTAzOWQALgAAAwtTe3WA8nZMqLdxh9lZAaoBANJ9sojKuvRMpCMoQfiuz5gAAAIBDQAAAA==/events?startTimeFrom=2025-03-18T22%3A55%3A31.952Z&startTimeTo=2025-04-01T22%3A55%3A31.952Z&perPage=100
03-25 22:55:31.955 INFO EnhancedHttpLoggingInterceptor.intercept(line:28) >>> --> GET http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788203004/cloud-calendars/ucc/exchange/~/AQMkAGVjOTUxODEwLTViMmUtNDJkZAAtODQxOC1mYWJhMTlkOTAzOWQALgAAAwtTe3WA8nZMqLdxh9lZAaoBANJ9sojKuvRMpCMoQfiuz5gAAAIBDQAAAA==/events?startTimeFrom=2025-03-18T22%3A55%3A31.952Z&startTimeTo=2025-04-01T22%3A55%3A31.952Z&perPage=100 
03-25 22:55:34.679 INFO EnhancedHttpLoggingInterceptor.intercept(line:45) >>> <-- RCRequestId = 602ba791-b75a-4bdb-86cd-f67c65141a57
03-25 22:55:34.680 INFO EnhancedHttpLoggingInterceptor.intercept(line:47) >>> <-- 200 OK http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788203004/cloud-calendars/ucc/exchange/~/AQMkAGVjOTUxODEwLTViMmUtNDJkZAAtODQxOC1mYWJhMTlkOTAzOWQALgAAAwtTe3WA8nZMqLdxh9lZAaoBANJ9sojKuvRMpCMoQfiuz5gAAAIBDQAAAA==/events?startTimeFrom=2025-03-18T22%3A55%3A31.952Z&startTimeTo=2025-04-01T22%3A55%3A31.952Z&perPage=100 (2723ms 61-byte [])
03-25 22:55:34.681 INFO MyHttpLoggingInterceptor.lambda$getHttpLoggingInterceptor$0(line:15)>>> <-- 200 OK http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788203004/cloud-calendars/ucc/exchange/~/AQMkAGVjOTUxODEwLTViMmUtNDJkZAAtODQxOC1mYWJhMTlkOTAzOWQALgAAAwtTe3WA8nZMqLdxh9lZAaoBANJ9sojKuvRMpCMoQfiuz5gAAAIBDQAAAA==/events?startTimeFrom=2025-03-18T22%3A55%3A31.952Z&startTimeTo=2025-04-01T22%3A55%3A31.952Z&perPage=100 (2726ms, unknown-length body)
03-25 22:55:34.682 INFO CINPlatformApiClient.getCalendarEventList(line:178)>>> {"records":[],"paging":{"perPage":100}}
03-25 22:55:34.684 INFO MyHttpLoggingInterceptor.lambda$getHttpLoggingInterceptor$0(line:15)>>> --> GET http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788225004/cloud-calendars/ucc/exchange/~/AAMkADQxNDdlMjU3LTdiZWUtNGE0Zi1hMGY1LWUyY2NhYmQ0YTYwMgAuAAAAAAA4nGMOp42UQ6YiGwGZBZiFAQBvWiZgUUm+QrF9b3TZjoTpAAAAAAENAAA=/events?startTimeFrom=2025-03-18T22%3A55%3A34.683Z&startTimeTo=2025-04-01T22%3A55%3A34.683Z&perPage=100
03-25 22:55:34.684 INFO EnhancedHttpLoggingInterceptor.intercept(line:28) >>> --> GET http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788225004/cloud-calendars/ucc/exchange/~/AAMkADQxNDdlMjU3LTdiZWUtNGE0Zi1hMGY1LWUyY2NhYmQ0YTYwMgAuAAAAAAA4nGMOp42UQ6YiGwGZBZiFAQBvWiZgUUm+QrF9b3TZjoTpAAAAAAENAAA=/events?startTimeFrom=2025-03-18T22%3A55%3A34.683Z&startTimeTo=2025-04-01T22%3A55%3A34.683Z&perPage=100 
03-25 22:55:37.145 INFO EnhancedHttpLoggingInterceptor.intercept(line:45) >>> <-- RCRequestId = 2d0c3638-a45b-4869-b1f8-ee017226ace4
03-25 22:55:37.145 INFO EnhancedHttpLoggingInterceptor.intercept(line:47) >>> <-- 200 OK http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788225004/cloud-calendars/ucc/exchange/~/AAMkADQxNDdlMjU3LTdiZWUtNGE0Zi1hMGY1LWUyY2NhYmQ0YTYwMgAuAAAAAAA4nGMOp42UQ6YiGwGZBZiFAQBvWiZgUUm+QrF9b3TZjoTpAAAAAAENAAA=/events?startTimeFrom=2025-03-18T22%3A55%3A34.683Z&startTimeTo=2025-04-01T22%3A55%3A34.683Z&perPage=100 (2458ms 61-byte [])
03-25 22:55:37.146 INFO MyHttpLoggingInterceptor.lambda$getHttpLoggingInterceptor$0(line:15)>>> <-- 200 OK http://shared-cin-xmnup.int.rclabenv.com:8080/restapi/v1.0/account/788203004/extension/788225004/cloud-calendars/ucc/exchange/~/AAMkADQxNDdlMjU3LTdiZWUtNGE0Zi1hMGY1LWUyY2NhYmQ0YTYwMgAuAAAAAAA4nGMOp42UQ6YiGwGZBZiFAQBvWiZgUUm+QrF9b3TZjoTpAAAAAAENAAA=/events?startTimeFrom=2025-03-18T22%3A55%3A34.683Z&startTimeTo=2025-04-01T22%3A55%3A34.683Z&perPage=100 (2461ms, unknown-length body)
03-25 22:55:37.166 INFO AsyncTaskPool.execute(line:21)                    >>> execute taskRunner:com.ringcentral.ta.glip.cucumber.hooks.common.async.chain.DynamicSyncTaskChain@3610ee8e
03-25 22:55:37.167 INFO AsyncTaskContext.schedule(line:45)                >>> scheduled task: DynamicSyncTaskChain-907079310, main thread: MTR-112818-7e098f5e-e412-45ec-b7a3-08de3013ab52
03-25 22:55:40.310 INFO BeatsV2ApiClient.updateTestOption(line:246)       >>> update test option success
03-25 22:55:40.310 INFO EnhancedHttpLoggingInterceptor.intercept(line:28) >>> --> GET https://api-beats-xmn.int.rclabenv.com/api/web/v1/test/76349724/ 
03-25 22:55:40.357 INFO EnhancedHttpLoggingInterceptor.intercept(line:47) >>> <-- 200 OK https://api-beats-xmn.int.rclabenv.com/api/web/v1/test/76349724/ (44ms 5023-byte [id=76349724, oid=3839647, errors_oid=[{text=[SERVICE_WEB_API_ENV_ERROR] com.ringcentral.tod.exceptions.apiException.backend.ServiceWebApiException: HTTP 502 Bad Gateway, oid=8178a613-e383-3558-8119-9ae540791ab7, date_created=2023-09-27}]])
03-25 22:55:40.358 INFO BeatsApiClient.getTestDetailed(line:107)          >>> get test info for test = 76349724 success: {"id":76349724,"name":"mtr-112818;schedule-an-ongoing-e2ee-meeting-on-room-s-upcoming-list-and-tap-join-with-id--\u003e-input-e2ee-meeting-id.-accounttype\u003d\"\u003caccounttype\u003e\";;2","description":"【 MTR-112818-7e098f5e-e412-45ec-b7a3-08de3013ab52 】Schedule an ongoing E2EE meeting on room\u0027s upcoming list and Tap Join with ID -\u003e Input E2EE meeting ID. accountType\u003d\"rooms-calendar-connected\"","project":3,"rerun_parent":0,"process_name":"Run","status":8,"process":0,"start_time":"2025-03-25T22:52:33.961000+08:00","run":1209911,"status_name":"Failed","group":"MTR-112818","metadata":{"Tags":"@MTR-112818,@P1,@Hylon,@AndroidHost,@AndroidController,@RoomsHost,@PAC,@XMN-UP,@RestartBluetooth,@MTR-112818-1,@RoomCINTest.LDRoom,@RC,@CrossVideo.android.1,@StableAndroidRCV","UDID1":"R52N919EZWZ","UDID2":"R52N61JKQGJ","UDID3":"1A071FDF600BW1","appUrls":"{\"1A071FDF600BW1\":[\"/Users/rcadmin/Downloads/apps/xmn-up-ringcentral-inhouse-debug.apk\",null],\"R52N919EZWZ\":[\"/Users/rcadmin/Downloads/apps/Rooms-XMN-UP.apk\",null],\"R52N61JKQGJ\":[\"/Users/rcadmin/Downloads/apps/Rooms-XMN-UP.apk\",null]}","envName":"xmn-up","tagList":"@MTR-112818,@P1,@Hylon,@AndroidHost,@AndroidController,@RoomsHost,@PAC,@XMN-UP,@RestartBluetooth,@MTR-112818-1,@RoomCINTest.LDRoom,@RC,@CrossVideo.android.1,@StableAndroidRCV","AppLog_0":"http://shares-xmn02.int.rclabenv.com/reports_logs/sdet/mThor-TA-Android-RCV-CrossVideo/1399/target/log/android/MTR-112818-7e098f5e-e412-45ec-b7a3-08de3013ab52","AppLog_1":"http://shares-xmn02.int.rclabenv.com/reports_logs/sdet/mThor-TA-Android-RCV-CrossVideo/1399/target/log/android/MTR-112818-7e098f5e-e412-45ec-b7a3-08de3013ab52","AppLog_2":"http://shares-xmn02.int.rclabenv.com/reports_logs/sdet/mThor-TA-Android-RCV-CrossVideo/1399/target/log/crossVideo/android/MTR-112818-7e098f5e-e412-45ec-b7a3-08de3013ab52","platform":"android","version1":"13","version2":"9","version3":"15","AppiumLog":"http://shares-xmn02.int.rclabenv.com/reports_logs/sdet/mThor-TA-Android-RCV-CrossVideo/1399/AppiumLogs/25-Mar-2025/MTR-112818-7e098f5e-e412-45ec-b7a3-08de3013ab52.log","ThreadLog":"http://shares-xmn02.int.rclabenv.com/reports_logs/sdet/mThor-TA-Android-RCV-CrossVideo/1399/ThreadLogs/25-Mar-2025/MTR-112818-7e098f5e-e412-45ec-b7a3-08de3013ab52.txt","accountId":"788203004","GroupBuild":"2167-rcv-android","appiumUrl1":"http://10.32.46.140:4739/","appiumUrl2":"http://10.32.46.144:4732/","appiumUrl3":"http://10.32.46.144:4730/","deviceType":"ANDROID","accountInfo":"12027460755,kamino1734318764542.com","accountType":"rooms-calendar-connected","deviceName1":"s1_behind_l1","deviceName2":"167","deviceName3":"Pixel 6","scenarioUri":"src/features/RCVOnly/PhoneAsController/E2EE/MTR-112818.feature:41","accountBrand":"RC US","deviceModel1":"SM-P610","deviceModel2":"SM-T307U","deviceModel3":"Pixel 6","Device_IP_List":"10.32.57.138,10.32.57.18,10.32.58.3","Create Bug Link":"http://aqa01-i01-ocr01.int.rclabenv.com/createBug?testId\u003d76349724","Page/Source/URL/0":"http://sdet-mobile-tools.int.rclabenv.com:5678/MTR-112818-7e098f5e-e412-45ec-b7a3-08de3013ab52/0/android","Page/Source/URL/1":"http://sdet-mobile-tools.int.rclabenv.com:5678/MTR-112818-7e098f5e-e412-45ec-b7a3-08de3013ab52/1/android","Page/Source/URL/2":"http://sdet-mobile-tools.int.rclabenv.com:5678/MTR-112818-7e098f5e-e412-45ec-b7a3-08de3013ab52/2/android","Cucumber_Report_Link":"http://shares-xmn02.int.rclabenv.com/reports_logs/sdet/mThor-TA-Android-RCV-CrossVideo/1399/target/cucumber-html-reports/report-feature_src-features-RCVOnly-PhoneAsController-E2EE-MTR-112818-feature.html","AppBuildLink_android_R52N61JKQGJ":"https://odin.int.rclabenv.com/cicd/artifacts?packageName\u003dRCVRooms-Android\u0026version\u003d22\u0026shortVersion\u003d25.2.10","AppBuildLink_android_R52N919EZWZ":"https://odin.int.rclabenv.com/cicd/artifacts?packageName\u003dRCVRooms-Android\u0026version\u003d22\u0026shortVersion\u003d25.2.10","AppBuildLink_android_1A071FDF600BW1":"https://odin.int.rclabenv.com/cicd/artifacts?packageName\u003dRingCentral-Android\u0026version\u003d240222\u0026shortVersion\u003d25.2.10"},"manual_ids":["MTR-112818"],"priority":1,"oid":3839647,"errors_oid":[{"text":"[SERVICE_WEB_API_ENV_ERROR] com.ringcentral.tod.exceptions.apiException.backend.ServiceWebApiException: HTTP 502 Bad Gateway","date_created":"2023-09-27"}]}
03-25 22:55:40.358 INFO EnhancedHttpLoggingInterceptor.intercept(line:28) >>> --> GET https://api-beats-xmn.int.rclabenv.com/api/web/v1/test/?dsl=GroupBuild%3D%222167-rcv-android%22%20and%20run.cucumberOptions%20%21%7E%20%22rerun.txt%22%20and%20run.name%20%21%7E%20%22Rerun%22%20and%20rerun_parent%20%3D%20None%20and%20group%20%3D%20%22MTR-112818%22%20and%20start_time%20%3E%3D%20now%28%22-3d%22%29&limit=500&offset=0&ordering=id 
03-25 22:55:41.439 INFO EnhancedHttpLoggingInterceptor.intercept(line:47) >>> <-- 200 OK https://api-beats-xmn.int.rclabenv.com/api/web/v1/test/?dsl=GroupBuild%3D%222167-rcv-android%22%20and%20run.cucumberOptions%20%21%7E%20%22rerun.txt%22%20and%20run.name%20%21%7E%20%22Rerun%22%20and%20rerun_parent%20%3D%20None%20and%20group%20%3D%20%22MTR-112818%22%20and%20start_time%20%3E%3D%20now%28%22-3d%22%29&limit=500&offset=0&ordering=id (1079ms 5361-byte [])
03-25 22:55:41.440 INFO BeatsApiClient.queryTest(line:210)                >>> get test list by query GroupBuild="2167-rcv-android" and run.cucumberOptions !~ "rerun.txt" and run.name !~ "Rerun" and rerun_parent = None and group = "MTR-112818" and start_time >= now("-3d") info success for query, total count = 1, limit = 500, offset = 0
03-25 22:55:41.440 INFO WrapBeatsData.wrapLastTestId(line:107)            >>> latestId = 76345132
03-25 22:55:41.503 INFO BeatsV2ApiClient.updateTest(line:74)              >>> update testId:76349724 success
03-25 22:55:41.510 INFO RoomsBeforeHooks.setUpCrossApp(line:283)          >>> setUpCrossApp
03-25 22:55:41.511 INFO RoomsBeforeHooks.setUpCrossApp(line:290)          >>> {"number":"1","sipIndex":"1","platform":"android"}
03-25 22:55:41.511 INFO RoomsBeforeHooks.setUpCrossApp(line:299)          >>> var crossAppIndex = allDevices.size - crossAppNum = 2
03-25 22:55:41.600 INFO AsyncTaskPool.execute(line:21)                    >>> execute taskRunner:com.ringcentral.ta.glip.cucumber.hooks.common.async.chain.DynamicSyncTaskChain@5227eed7
03-25 22:55:41.600 INFO AsyncTaskContext.schedule(line:45)                >>> scheduled task: DynamicSyncTaskChain-1378348759, main thread: MTR-112818-7e098f5e-e412-45ec-b7a3-08de3013ab52
03-25 22:55:44.614 INFO DynamicSyncTaskChain.waitTaskFinish(line:61)      >>> wait DynamicSyncTaskChain task finish
03-25 22:55:53.801 INFO AsyncTaskContext.getTaskResult(line:59)           >>> Start waiting for task: DynamicSyncTaskChain-907079310
03-25 22:55:53.801 INFO AsyncTaskContext.getTaskResult(line:62)           >>> task: DynamicSyncTaskChain-907079310 finished with result: kotlin.Unit
03-25 22:55:53.802 INFO AsyncTaskContext.getTaskResult(line:59)           >>> Start waiting for task: DynamicSyncTaskChain-1378348759
03-25 22:55:53.802 INFO AsyncTaskContext.getTaskResult(line:62)           >>> task: DynamicSyncTaskChain-1378348759 finished with result: kotlin.Unit
03-25 22:55:53.829 INFO BeatsV2ApiClient.createStep(line:266)             >>> create step success, step id = 1660189196 ,step name =  Given  [RcvMeeting Api] create meetings by the user:"user701" with given properties: , time cost = 27ms"""
